package com.hotwj.platform.config.vehicleSecondaryMaintenanceConfig.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hotwj.platform.config.vehicleSecondaryMaintenanceConfig.domain.HotVehicleSecondaryMaintenanceConfig;
import com.hotwj.platform.config.vehicleSecondaryMaintenanceConfig.domain.bo.HotVehicleSecondaryMaintenanceConfigBo;
import com.hotwj.platform.config.vehicleSecondaryMaintenanceConfig.domain.vo.HotVehicleSecondaryMaintenanceConfigVo;
import com.hotwj.platform.config.vehicleSecondaryMaintenanceConfig.mapper.HotVehicleSecondaryMaintenanceConfigMapper;
import com.hotwj.platform.config.vehicleSecondaryMaintenanceConfig.service.IHotVehicleSecondaryMaintenanceConfigService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 车辆二级维护配置Service业务层处理
 *
 * @author shihongwei
 * @date 2025-12-19
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class HotVehicleSecondaryMaintenanceConfigServiceImpl implements IHotVehicleSecondaryMaintenanceConfigService {

    private final HotVehicleSecondaryMaintenanceConfigMapper baseMapper;

    /**
     * 查询车辆二级维护配置
     *
     * @param id 主键
     * @return 车辆二级维护配置
     */
    @Override
    public HotVehicleSecondaryMaintenanceConfigVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询车辆二级维护配置列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 车辆二级维护配置分页列表
     */
    @Override
    public TableDataInfo<HotVehicleSecondaryMaintenanceConfigVo> queryPageList(HotVehicleSecondaryMaintenanceConfigBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<HotVehicleSecondaryMaintenanceConfig> lqw = buildQueryWrapper(bo);
        Page<HotVehicleSecondaryMaintenanceConfigVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的车辆二级维护配置列表
     *
     * @param bo 查询条件
     * @return 车辆二级维护配置列表
     */
    @Override
    public List<HotVehicleSecondaryMaintenanceConfigVo> queryList(HotVehicleSecondaryMaintenanceConfigBo bo) {
        LambdaQueryWrapper<HotVehicleSecondaryMaintenanceConfig> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<HotVehicleSecondaryMaintenanceConfig> buildQueryWrapper(HotVehicleSecondaryMaintenanceConfigBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<HotVehicleSecondaryMaintenanceConfig> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(HotVehicleSecondaryMaintenanceConfig::getId);
        lqw.eq(bo.getCompanyId() != null, HotVehicleSecondaryMaintenanceConfig::getCompanyId, bo.getCompanyId());
        lqw.eq(bo.getIntervalYears() != null, HotVehicleSecondaryMaintenanceConfig::getIntervalYears, bo.getIntervalYears());
        lqw.eq(bo.getInspectionTimes() != null, HotVehicleSecondaryMaintenanceConfig::getInspectionTimes, bo.getInspectionTimes());
        lqw.eq(bo.getIsEnabled() != null, HotVehicleSecondaryMaintenanceConfig::getIsEnabled, bo.getIsEnabled());
        lqw.eq(bo.getIsDeleted() != null, HotVehicleSecondaryMaintenanceConfig::getIsDeleted, bo.getIsDeleted());
        return lqw;
    }

    /**
     * 新增车辆二级维护配置
     *
     * @param bo 车辆二级维护配置
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(HotVehicleSecondaryMaintenanceConfigBo bo) {
        HotVehicleSecondaryMaintenanceConfig add = MapstructUtils.convert(bo, HotVehicleSecondaryMaintenanceConfig.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改车辆二级维护配置
     *
     * @param bo 车辆二级维护配置
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(HotVehicleSecondaryMaintenanceConfigBo bo) {
        HotVehicleSecondaryMaintenanceConfig update = MapstructUtils.convert(bo, HotVehicleSecondaryMaintenanceConfig.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(HotVehicleSecondaryMaintenanceConfig entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除车辆二级维护配置信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
